@***********************************************************
@
@	by Rudolph (c)
@		2007/05/25 First release
@
@-----------------------------------------------------------
@  SoftwareReset Routines for EZ5.
@
@ Redistribution and use in source and binary forms,
@ with or without modification, are permitted provided 
@ that the following conditions are met:
@
@  Only the Homebrew application can be used. 
@  It is not possible to use it by a business purpose. 
@
@  This software is made based on information obtained 
@  by Reverse engineering. 
@
@  Please use that at once when a source code that is 
@  more formal than the official is open to the public.
@************************************************************

 .ALIGN
 .GLOBAL	ret_menu9_EZ5
 .CODE 32
 .ARM

ret_menu9_EZ5:
	mov	r2, #0x4000000
	str	r2, [r2, #+0x208]		@ *(04000208)=#0x4000000
	mov	r7, #0xE000
	str	r7, [r2, #+0x204]		@ *(04000204)=#0xE000

	ldr	r2, =0x027FF000
	ldr	r1, =0x40404040
_wait_a7:
	ldr	r0, [r2, #+0xFE4]
	cmp	r0, r1
	bne	_wait_a7			@ Wait *(027fffe4) == EZ5S

@	adr	r0, Arm9_reset
@	ldr	r1, =0x027FFE24
@	str	r0, [r1, #+0x0]			@ *(027ffe24)=ARM9_reset
@	swi	0x00000000



Arm9_reset:
	mov	r4, #0x4000000
	mov	r0, #0x0
	mvn	r1, #0x0
	str	r0, [r4, #+0x208]		@ *(04000208)=#0
	str	r0, [r4, #+0x210]		@ *(04000210)=#0
	str	r1, [r4, #+0x214]		@ *(04000214)=#0
	ldr	r0, =0x027FF000
	adr	r1, Arm7_reset

	mov	r10, #0x400			@ ARM7 program size (240)
Arm7_copy:
	ldmia	r1!, {r2,r3,r4,r5,r6,r7,r8,r9}
	stmia	r0!, {r2,r3,r4,r5,r6,r7,r8,r9}
	subs	r10, r10, #0x20
	bne	Arm7_copy


	mov	r1, #0x0
mcr_lp0:
	mov	r0, #0x0
mcr_lp1:
	orr	r2, r1, r0
	mcr	15, 0, r2, cr7, cr14, 2
	add	r0, r0, #0x20
	cmp	r0, #0x400
	bne	mcr_lp1

	add	r1, r1, #0x40000000
	cmp	r1,#0x0
	bne	mcr_lp0

	mov	r10, #0x0
	mcr	15, 0, r10, cr7, cr5, 0
	mcr	15, 0, r10, cr7, cr6, 0
	mcr	15, 0, r10, cr7, cr10, 4
	mcr	15, 0, r10, cr3, cr0, 0
	mcr	15, 0, r10, cr2, cr0, 0
	mov	r10, #0x800000
	add	r10, r10, #0xA
	mcr	15, 0, r10, cr9, cr1, 0
	mov	r10, #0xC
	mcr	15, 0, r10, cr9, cr1, 1
	mov	r10, #0x1F
	msr	CPSR_fc, r10
	ldr	r2, =0x00803000
	mov	r3, #0x0
	str	r3, [r2, #+0xFFC]		@ *(00803ffc)=#0
	mvn	r3, #0x0
	str	r3, [r2, #+0xFF8]		@ *(00803ff8)=#0xFFFFFFFF

	mov	r1, #0x0
	ldr	r2, =0x040000B0
	ldr	r4, =0x04000100
	mov	r0,r1

TimDMA_lp:
	str	r1, [r2], #+0x4
	str	r1, [r2], #+0x4
	str	r1, [r2], #+0x4
	strh	r1, [r4], #+0x2
	strh	r1, [r4], #+0x2
	add	r0, r0, #0x1
	cmp	r0, #0x4
	bne	TimDMA_lp

	mov	r0, #0x0
	ldr	r4, =0x027FFE04
	str	r0, [r4, #+0x0]			@ *(027ffe04)=#0
	ldr	r3, =0x80808080
	mov	r1, #0x4000000
	str	r3, [r1, #+0x240]		@ *(04000240)=#0x80808080
	mov	r3, #0x5000000
	mvn	r2, #0x0
	strh	r2, [r3, #+0x0]			@ *(05000000)=#0xFFFF
	add	r3, r3, #0x2
	str	r4, [r1, #+0xD4]		@ *(040000d4)=#0x027ffe04
	ldr	r2, =0x850001FF
	str	r3, [r1, #+0xD8]		@ *(040000d8)=#0x5000002
	str	r2, [r1, #+0xDC]		@ *(040000dc)=#0x850001ff

DMA_lp0:
	ldr	r3, [r1, #+0xDC]		@ r3 = *(040000dc)
	cmp	r3, #0x0
	blt	DMA_lp0

	mov	r2, #0x7000000
	str	r4, [r1, #+0xD4]		@ *(040000d4)=#0x027ffe04
	ldr	r3, =0x85000200
	str	r2, [r1, #+0xD8]		@ *(040000d8)=#0x7000000
	str	r3, [r1, #+0xDC]		@ *(040000dc)=#0x85000200
	add	r2, r2, #0xFD000000

DMA_lp1:
	ldr	r3, [r2, #+0xdc]
	cmp	r3, #0x0
	blt	DMA_lp1

	mov	r1, #0x4000000
	str	r4, [r2, #+0xD4]
	ldr	r3, =0x85000015
	str	r2, [r2, #+0xD8]
	str	r3, [r2, #+0xDC]
DMA_lp2:
	ldr	r3, [r1, #+0xDC]
	cmp	r3, #0x0
	blt	DMA_lp2

	ldr	r2, =0x04001000
	str	r4, [r1, #+0xD4]
	ldr	r3, =0x85000015
	str	r2, [r1, #+0xD8]
	str	r3, [r1, #+0xDC]
	mov	r1, #0x4000000
DMA_lp3:
	ldr	r3,[r1, #+0xDC]
	cmp	r3,#0x0
	blt	DMA_lp3


	mov	r2, #0x6800000
	str	r4, [r1, #+0xD4]
	ldr	r3, =0x85029000
	str	r2, [r1, #+0xD8]
	mov	r12, #0x4000000
	str	r3, [r1, #+0xDC]
DMA_lp4:
	ldr	r3, [r12, #+0xDC]
	cmp	r3, #0x0
	blt	DMA_lp4

	ldr	r1, =0x04000200
	ldr	r2, =0x04001000
	mov	r3, #0x0
	strh	r3, [r12, #+0x4]	@ *(04000004)=#0
	ldr	r0, =0xffff820f
	str	r3, [r12, #+0x0]	@ *(04000000)=#0
	str	r3, [r2, #+0x0]		@ *(04001000)=#0
	strb	r3, [r1, #+0x40]	@ *(04000240)=#0
	mov	r2, #0x3000000
	strb	r3, [r1, #+0x41]	@ *(04000241)=#0
	strb	r3, [r1, #+0x42]	@ *(04000242)=#0
	strb	r3, [r1, #+0x43]	@ *(04000243)=#0
	strb	r3, [r1, #+0x44]	@ *(04000244)=#0
	strb	r3, [r1, #+0x45]	@ *(04000245)=#0
	strb	r3, [r1, #+0x46]	@ *(04000246)=#0
	strb	r3, [r1, #+0x48]	@ *(04000248)=#0
	strb	r3, [r1, #+0x49]	@ *(04000249)=#0
	ldr	r3, =0x04000300
	str	r2, [r12, #+0x240]	@ *(04000240)=#0x3000000
	mov 	r2, #0x3
	strh	r0, [r3, #+0x4]		@ *(04000304)=0xffff820f
	strb	r2, [r1, #+0x47]	@ *(04000247)=#0x3


	ldr	r5, =0x040001a4
	ldr	r6, =0x04100010
	ldr	r7, =0xa7586000
	ldr	r0, =0xb9ff55aa
	mov	r1, #0x0
	bl	_card_sub
	str	r7, [r5, #+0x0]
card_lp0:
	ldr	r0, [r5, #+0x0]
	ands	r0, r0,#0x800000
	beq	card_lp0
	ldr	r0, [r6, #+0x0]

	ldr	r0, =0xb8f40100
	ldr	r1, =0x55aa5500
	bl	_card_sub
	str	r7, [r5, #+0x0]
card_lp1:
	ldr	r0, [r5, #+0x0]
	ands	r0, r0, #0x800000
	beq	card_lp1
	ldr	r0, [r6, #+0x0]

	mov	r3, #0x4000000
	mov	r4, #0x8000000
	ldr	r5, =0x0000e880
	str	r5, [r4, #+0x0]
	str	r5, [r3, #+0x204]	@ *(04000204)=#0x0000e880

	ldr	r2, =0x027FF000
	ldr	r1, =0x53355A45
	str	r1, [r2, #+0xFE4]	@ *(027fffe4)=EZ5S

	ldr	r0, =0x027ff6c0
	ldr	r2, =0xe51ff004
	add	r3, r0, #0x4
	str	r2, [r0, #+0x4]		@ *(027ff6c4) = ldr r15,[r15, #-0x4]
	str	r3, [r0, #+0x8]		@ *(027ff6c8)=#0x027ff6c4
	bx	r3			@ JUMP 0x027ff6c4


_card_sub:
	ldr	r11,=0x040001a4
_card_sub0:
	ldr	r10, [r11, #+0x0]
	ands	r10, r10, #0x80000000
	bne	_card_sub0

	mov	r10, #0xC0
	ldr	r11, =0x040001a1
	strb	r10, [r11, #+0x0]
	mov	r10, r0, lsr #0x18
	ldr	r11, =0x040001a8
	strb	r10, [r11], #+0x1
	mov	r10, r0, lsr #0x10
	strb	r10, [r11], #+0x1
	mov	r10, r0, lsr #0x8
	strb	r10, [r11], #+0x1
	strb	r0, [r11], #+0x1
	mov	r10, r1, lsr #0x18
	strb	r10, [r11], #+0x1
	mov	r10, r1, lsr #0x10
	strb	r10, [r11], #+0x1
	mov	r10, r1, lsr #0x8
	strb	r10, [r11], #+0x1
	strb	r1, [r11], #+0x1
	bx	r14


@=========== ARM7 ============

Arm7_reset:
	mov	r0, #0x4000000
	mvn	r3, #0xFC000000
	mov	r1, #0x0
	mvn	r2, #0x0
	str	r1, [r0, #+0x208]	@ *(04000208)=#0
	strh	r1, [r0, #+0x4]		@ *(04000004)=#0
	str	r1, [r0, #+0x210]	@ *(04000210)=#0
	str	r2, [r0, #+0x214]	@ *(04000214)=#0xFFFFFFFF
	str	r1, [r3, #-0x3]		@ *(040002fd)=#0
	str	r2, [r3, #-0x7]		@ *(040002f9)=#0xFFFFFFFF
	add 	r4, r0, #0x400
	add	r5, r0, #0x500
_init_0:
	str	r1, [r4], #+0x4
	str	r1, [r4], #+0x4
	strh	r1, [r4], #+0x2
	strh	r1, [r4], #+0x2
	str	r1, [r4], #+0x4
	cmp	r5, r4
	bhi	_init_0

	str	r1, [r5, #+0x0]		@ *(04000500)=#0
	add	r4, r0, #0xB0
	add	r5, r0, #0x100
	mov	r3, #0x0
_init_1:
	str	r1, [r4], #+0x4
	str	r1, [r4], #+0x4
	str	r1, [r4], #+0x4
	strh	r1, [r5], #+0x2
	strh	r1, [r5], #+0x2
	add	r3, r3, #0x1
	cmp	r3, #0x4
	bne	_init_1

	mov	r0, #0x0
	mov	r1, #0x0
	mov	r2, #0x0
	mov	r3, #0x0
	mov	r4, #0x0
	mov	r5, #0x0
	mov	r6, #0x0
	mov	r7, #0x0
	mov	r11, #0x2000000
	ldr	r12, =0x023ff000
_init_2:
	stmia	r11!, {r0,r1,r2,r3,r4,r5,r6,r7}
	cmp	r11, r12
	bne	_init_2

	mov	r8, #0x3780000
	mov	r9, #0x3800000
	orr	r9, r9, #0x10000
_init_3:
	stmia	r8!, {r0,r1,r2,r3,r4,r5,r6,r7}
	cmp	r8, r9
	blt	_init_3


	mov	r0, #0x0
	ldr	r1, =0x027ffe00
	mov	r7, r0
	bl	_card_read

	ldr	r1, =0x027ffe00
	ldr	r2, [r1, #+0x20]	@ r2 = *(027ffe20)
	ldr	r3, [r1, #+0x28]	@ r3 = *(027ffe28)
	ldr	r4, [r1, #+0x2c]	@ r4 = *(027ffe2c)
	add	r0, r7, r2
	mov	r1, r3
_init_4:
	bl	_card_read

	add	r0, r0, #0x200
	subs	r4, r4, #0x200
	bhi	_init_4

	ldr	r1, =0x027ffe00
	ldr	r2, [r1, #+0x30]	@ r2 = *(027ffe30)
	ldr	r3, [r1, #+0x38]	@ r3 = *(027ffe38)
	ldr	r4, [r1, #+0x3c]	@ r4 = *(027ffe3c)
	add	r0, r7, r2
	mov	r1, #0x3800000
_init_5:
	bl	_card_read

	add	r0, r0, #0x200
	subs	r4, r4, #0x200
	bhi	_init_5

	ldr	r0, =0x027fff5e
	ldrh	r0, [r0, #+0x0]		@ r0 = *(027fff5e)
	ldr	r1, =0x027ff808
	strh	r0, [r1, #+0x0]		@ *(027ff808)=*(027fff5e)
	ldr	r1, =0x027ffc08
	strh	r0, [r1, #+0x0]		@ *(027ffc08)=*(027fff5e)
	ldr	r1, =0x027ffe6c
	ldrh	r0, [r1, #+0x0]		@ *(027ffe6c)=*(027fff5e)
	ldr	r1, =0x027ff80a
	strh	r0, [r1, #+0x0]		@ *(027ff80a)=*(027fff5e)
	ldr	r1, =0x027ffc0a
	strh	r0, [r1, #+0x0]		@ *(027ffc0a)=*(027fff5e)
	mov	r5, #0x8300000
	str	r1, [r5, #+0x0]		@ *(08300000)=#0x027ffc0a
	mov	r4, #0x4000000
	mov	r1, #0x1
	str	r1, [r4, #+0x304]	@ *(04000304)=#0x01
	ldr	r6, =0x027ff000
	ldr	r3, [r6, #+0xe24]	@ r3 = *(027ffe24)
	str	r3, [r6, #+0x6c8]	@ *(027ff6c8)=*(027ffe24)
	str	r3, [r6, #+0x6c8]	@ *(027ff6c8)=*(027ffe24)
	swi	0x00000000


_card_read:
	mov	r8, r0
	mov	r9, r1
	mov	r1, r0
	mov	r0, r1, lsr #0x8
	orr	r0, r0, #0xB7000000
	mov	r1, r1, lsl #0x18
	mov	r12, r14
	bl	_card_r2

	mov	r14, r12
	ldr	r10, =0x00586000
	bic	r10, r10, #0x7000000
	orr	r10, r10, #0xA1000000
	ldr	r11, =0x040001a4
	ldr	r12, =0x04100010
	str	r10, [r11, #+0x0]
_card_r0:
	ldr	r10, [r11, #+0x0]
	ands	r1, r10, #0x800000
	beq	_card_r1

	ldr	r0, [r12, #+0x0]
	str	r0, [r9], #+0x4
_card_r1:
	ands	r1, r10, #0x80000000
	bne	_card_r0

	mov	r0, r8
	mov	r1, r9
	bx	r14

_card_r2:
	ldr	r11, =0x040001a4
_card_r3:
	ldr	r10, [r11, #+0x0]
	ands	r10, r10, #0x80000000
	bne	_card_r3

	mov	r10, #0xC0
	ldr	r11, =0x040001a1
	strb	r10, [r11, #+0x0]
	mov	r10, r0, lsr #0x18
	ldr	r11, =0x040001a8
	strb	r10, [r11], #+0x1
	mov	r10, r0, lsr #0x10
	strb	r10, [r11], #+0x1
	mov	r10, r0, lsr #0x8
	strb	r10, [r11], #+0x1
	strb	r0, [r11], #+0x1
	mov	r10, r1, lsr #0x18
	strb	r10, [r11], #+0x1
	mov	r10, r1, lsr #0x10
	strb	r10, [r11], #+0x1
	mov	r10, r1, lsr #0x8
	strb	r10, [r11], #+0x1
	strb	r1, [r11], #+0x1
	bx	r14

 .END

